%define oname ffmpeg

%define major 52

%define libname %mklibname avcodec %{major}

%define avfmajor 52
%define avflibname %mklibname avformats %{avfmajor}
%define postprocmajor 51
%define postproclibname %mklibname postproc %{postprocmajor}

%define avumajor 50
%define avulibname %mklibname avutil %{avumajor}
%define swsmajor 0
%define swslibname %mklibname swscaler %{swsmajor}

%define filtermajor 1
%define filterlibname %mklibname avfilter %{filtermajor}

%define devname %mklibname %{name} -d
%define sdevname %mklibname %{name} -s -d

%define build_swscaler 1
%define build_plf 0
%{?_with_plf: %{expand: %%global build_plf 1}}
%if %{build_plf}
%define distsuffix plf
%define extrarelsuffix plf
%endif

%define build_faac 0

Summary:	Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Name:		%{oname}0.7
Version:	0.7.16
Release:	1%{?extrarelsuffix}
%if %{build_plf}
License:	GPLv3+
%else
License:	GPLv2+
%endif
Group:		Video
Url:		http://ffmpeg.org/
Source0:	http://ffmpeg.org/releases/%{oname}-%{version}.tar.bz2
Patch0:		ffmpeg-0.7.16-makefile.patch
BuildRequires:	texi2html
BuildRequires:	yasm
BuildRequires:	jpeg-devel
BuildRequires:	bzip2-devel
%if %{build_faac}
BuildRequires:	libfaac-devel
%endif
BuildRequires:	pkgconfig(jack)
BuildRequires:	pkgconfig(libdc1394-2)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(librtmp)
BuildRequires:	pkgconfig(libva)
BuildRequires:	pkgconfig(schroedinger-1.0)
BuildRequires:	pkgconfig(sdl)
BuildRequires:	pkgconfig(theora)
BuildRequires:	pkgconfig(vdpau)
BuildRequires:	pkgconfig(vorbis)
BuildRequires:	pkgconfig(vpx)
%if %{build_plf}
BuildRequires:	lame-devel
BuildRequires:	pkgconfig(opencore-amrnb)
BuildRequires:	pkgconfig(opencore-amrwb)
BuildRequires:	pkgconfig(x264)
%endif

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%if %{build_plf}
This package is in Restricted repository as it violates several patents.
%endif

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries
Provides:	libffmpeg = %{EVRD}
Conflicts:	%{_lib}ffmpeg52 < 0.7.13-5
Obsoletes:	%{_lib}ffmpeg52 < 0.7.13-5

%description -n %{libname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%files -n %{libname}
%{_libdir}/libavcodec.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{postproclibname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries
Conflicts:	%{_lib}ffmpeg51

%description -n %{postproclibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%files -n %{postproclibname}
%{_libdir}/libpostproc.so.%{postprocmajor}*

#----------------------------------------------------------------------------

%package -n %{avflibname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries

%description -n %{avflibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%files -n %{avflibname}
%{_libdir}/libavformat.so.%{avfmajor}*
%{_libdir}/libavdevice.so.%{avfmajor}*

#----------------------------------------------------------------------------

%package -n %{avulibname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries

%description -n %{avulibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%files -n %{avulibname}
%{_libdir}/libavutil.so.%{avumajor}*

#----------------------------------------------------------------------------

%package -n %{swslibname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries
Requires:	%{avulibname} = %{EVRD}

%description -n %{swslibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%if %{build_swscaler}
%files -n %{swslibname}
%{_libdir}/libswscale.so.%{swsmajor}*
%endif

#----------------------------------------------------------------------------

%package -n %{filterlibname}
Summary:	Shared library part of ffmpeg
Group:		System/Libraries

%description -n %{filterlibname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg if you want to encode multimedia streams.

%files -n %{filterlibname}
%{_libdir}/libavfilter.so.%{filtermajor}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Header files for the ffmpeg codec library
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Requires:	%{avflibname} = %{EVRD}
Requires:	%{avulibname} = %{EVRD}
Requires:	%{postproclibname} >= %{EVRD}
%if %{build_swscaler}
Requires:	%{swslibname} = %{EVRD}
%endif
Requires:	%{filterlibname} = %{EVRD}
Provides:	ffmpeg0.7-devel = %{EVRD}
Conflicts:	%{_lib}ffmpeg-devel

%description -n %{devname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%files -n %{devname}
%doc INSTALL README doc/*.html doc/*.txt doc/TODO doc/*.conf
%{_includedir}/libavcodec
%{_includedir}/libavdevice
%{_includedir}/libavformat
%{_includedir}/libavutil
%{_includedir}/libpostproc
%{_includedir}/libavfilter
%{_libdir}/libavcodec.so
%{_libdir}/libavdevice.so
%{_libdir}/libavformat.so
%{_libdir}/libavutil.so
%{_libdir}/libpostproc.so
%{_libdir}/libavfilter.so
%if %{build_swscaler}
%{_libdir}/libswscale.so
%{_includedir}/libswscale
%{_libdir}/pkgconfig/libswscale.pc
%endif
%{_libdir}/pkgconfig/libavcodec.pc
%{_libdir}/pkgconfig/libavdevice.pc
%{_libdir}/pkgconfig/libavformat.pc
%{_libdir}/pkgconfig/libavutil.pc
%{_libdir}/pkgconfig/libpostproc.pc
%{_libdir}/pkgconfig/libavfilter.pc

#----------------------------------------------------------------------------

%package -n %{sdevname}
Summary:	Static library for the ffmpeg codec library
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	ffmpeg0.7-static-devel = %{EVRD}

%description -n %{sdevname}
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%files -n %{sdevname}
%{_libdir}/*.a
%{_libdir}/libavformat/*a
%{_libdir}/libavcodec/*a

#----------------------------------------------------------------------------

%prep
%setup -q -n %{oname}-%{version}
%patch0 -p1

%build
%define Werror_cflags %nil
export CFLAGS="%{optflags} -FPIC"
export LDFLAGS="%{ldflags}"

./configure --prefix=%{_prefix} \
	--enable-shared \
	--libdir=%{_libdir} \
	--shlibdir=%{_libdir} \
	--incdir=%{_includedir} \
	--disable-stripping \
	--enable-postproc \
	--enable-gpl \
	--enable-pthreads \
	--enable-libtheora \
	--enable-libvorbis --disable-encoder=vorbis \
	--enable-libvpx \
	--enable-x11grab \
	--enable-runtime-cpudetect \
	--enable-libdc1394 \
	--enable-libschroedinger \
	--enable-librtmp \
%if %{build_plf}
	--enable-libmp3lame \
	--enable-libopencore-amrnb \
	--enable-libopencore-amrwb \
	--enable-version3 \
	--enable-libx264 \
%else
	--disable-decoder=aac --disable-encoder=aac \
%endif
%if %{build_faac}
	--enable-nonfree --enable-libfaac
%endif

%make

%install
%makeinstall_std SRC_PATH=`pwd`

# compat symlink
install -d %{buildroot}%{_libdir}/libavcodec
pushd %{buildroot}%{_libdir}/libavcodec && ln -sf ../libavcodec.a && popd
install -d %{buildroot}%{_libdir}/libavformat
pushd %{buildroot}%{_libdir}/libavformat && ln -sf ../libavformat.a && popd

#gw don't package these:
rm -rf %{buildroot}%{_bindir}
rm -rf %{buildroot}%{_mandir}/man1
rm -rf %{buildroot}%{_datadir}/%{oname}
#gw same major as in ffmpeg 0.8.x, use that one instead
#rm -f %buildroot%{_libdir}/libpostproc.so.%{postprocmajor}*


%changelog
* Mon Jul 07 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.7.16-1
+ Revision: 69e5330
- Don't even build progs and docs


